#include "stdafx.h"
#include "CheesyOscilloscopeVisComponent.h"

CCheesyOscilloscopeVisComponent::CCheesyOscilloscopeVisComponent()
{
	// call this in the contstructor to load the defaults
	SetData(NULL);
}

CCheesyOscilloscopeVisComponent::~CCheesyOscilloscopeVisComponent()
{
}

int CCheesyOscilloscopeVisComponent::GetData(COMPONENT_PROPERTY_DATA_ARRAY & aryPropertyData)
{
	// add all our properties to the array
	// see other component for an example

	return 0;
}

int CCheesyOscilloscopeVisComponent::SetData(const COMPONENT_PROPERTY_DATA_ARRAY * paryPropertyData)
{
	// set the defaults

	// load any settings passed in
	if (paryPropertyData)
	{
		for (int z = 0; z < paryPropertyData->GetSize(); z++)
		{
			COMPONENT_PROPERTY_DATA * pPropertyData = paryPropertyData->GetAt(z);

			// see other component for an example
		}
	}

	// set the initialized flag to false, so we re-initialize next draw
	m_bInitialized = FALSE;
	return 0;
}

int CCheesyOscilloscopeVisComponent::Initialize()
{
	// do any loading / initialization in here

	// update the initialized flag
	m_bInitialized = TRUE;

	return 0;
}
    
int CCheesyOscilloscopeVisComponent::Draw(IVisBuffer * pBuffer, IVisData * pVisData)
{
	// initialize if necessary (when settings change, etc.)
	if (m_bInitialized == FALSE)
		Initialize();

	// create a buffer helper, and use it (provides a lot of fast, handy fuctions)
	CVisBufferHelper VisBuffer(pBuffer);

	// attach a CDC to the buffer so we can do GDI drawing stuff
	CDC cdcBuffer; 
	cdcBuffer.Attach(VisBuffer.GetHDC(0));

	// lets draw a cheesy polyline oscilloscope
	POINT aryPoints[1024]; memset(&aryPoints[0], 0, sizeof(aryPoints));

	// get a few numbers
	int nMidY = VisBuffer.GetHeight() / 2;
	int nMaxDeltaY = VisBuffer.GetHeight() / 4;
	int nPixelsBetweenPointsX = max(VisBuffer.GetWidth() / 1024, 1);
	
	// get the wave data
	VIS_DATA * pIntVisData = pVisData->GetVisData();
	
	for (int z = 0; z < 1024; z++)
	{
		// figure x
		int nX = (z * VisBuffer.GetWidth()) / 1024;
		
		// figure delta Y (128 is the max value -128 to 127)
		// note: cWaveData[0][z] is left, cWaveData[1][z] is right
		int nDeltaY = ((nMaxDeltaY * pIntVisData->cWaveData[0][z]) / 128);
		
		// set the points values
		aryPoints[z].x = nX;
		aryPoints[z].y = nMidY + nDeltaY;
	}

	// create and select a pen
	CPen penOscilloscope(PS_SOLID, 2, RGB(255, 255, 255));
	CPen * pOldPen = cdcBuffer.SelectObject(&penOscilloscope);

	// draw the oscilloscope
	cdcBuffer.Polyline(&aryPoints[0], 1024);
	
	// clean-up and detach the CDC
	cdcBuffer.SelectObject(pOldPen);
	cdcBuffer.Detach();

	return 0;
}

