#include "stdafx.h"

#include "GradientFillVisComponent.h"
#include "CheesyOscilloscopeVisComponent.h"

#define INDEX_GRADIENT_FILL			0
#define INDEX_CHEESY_OSCILLOSCOPE	1

extern "C" __declspec(dllexport) 
void GetRegistrationInfo(VISUALIZATION_REGISTRATION_INFO * pInfo)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	strcpy(pInfo->cName, "Sample 1");
	strcpy(pInfo->cDescription, "Media Jukebox Sample 1 Components");
	strcpy(pInfo->cCopyright, "Copyright (C) 1998-2002, J. River, Inc.");
	strcpy(pInfo->cWebsite, "www.mediajukebox.com");
	strcpy(pInfo->cVersion, "1.0.2");
}

/************************************************************************************
IMPORTANT: always generate a new GUID for each component (using UUIDGEN.exe, etc.)
************************************************************************************/
extern "C" __declspec(dllexport) 
int GetComponentInfo(int nIndex, VISUALIZATION_COMPONENT_INFO * pInfo)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	BOOL bFound = TRUE;
	
	pInfo->nVersion = 1;

	switch (nIndex)
	{
	case INDEX_GRADIENT_FILL:
		strcpy(&pInfo->cGUID[0], "4a6f929b-8e07-4da6-ac83-22b2247c021f");
		pInfo->ComponentType = COMPONENT_TYPE_TRANSFORM;
		strcpy(pInfo->cComponentName, "Gradient Fill");
		strcpy(pInfo->cComponentDescription, "Fills the screen with a gradient.");
		break;
	case INDEX_CHEESY_OSCILLOSCOPE:
		strcpy(&pInfo->cGUID[0], "ca5bbf04-ad4d-44f2-953f-3299b1163eaa");
		pInfo->ComponentType = COMPONENT_TYPE_DRAW;
		strcpy(pInfo->cComponentName, "Cheesy Oscilloscope");
		strcpy(pInfo->cComponentDescription, "Draws a cheesy oscilloscope ;)");
		break;
	default:
		bFound = FALSE;
	}

	return (bFound == TRUE) ? 0 : -1;
}

extern "C" __declspec(dllexport) 
int CreateComponent(int nIndex, CVisComponent ** ppComponent)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	*ppComponent = NULL;
	
	switch (nIndex)
	{
	case INDEX_GRADIENT_FILL:
		*ppComponent = new CGradientFillVisComponent();
		break;
	case INDEX_CHEESY_OSCILLOSCOPE:
		*ppComponent = new CCheesyOscilloscopeVisComponent();
		break;
	}

	return (*ppComponent == NULL) ? -1 : 0;
}