// GradientEx.h: interface for the CGradientEx class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GRADIENTEX_H__5868E821_3D0B_44D7_8733_4B0843FC1A58__INCLUDED_)
#define AFX_GRADIENTEX_H__5868E821_3D0B_44D7_8733_4B0843FC1A58__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CGradientEx  
{
public:
	CGradientEx();
	virtual ~CGradientEx();

	unsigned int GetColor(float fX, float fY);

	int DestroyQuickLookupTable();
	int BuildQuickLookupTable(float fY, int nTableElements);

	int Save(CString strFileName, CString strKey, CString strDescription = "Gradient");
	int Load(CString strFileName, CString strKey, CString strDescription = "Gradient");
	
	CString SaveToString();
	void LoadFromString(CString strGradient);

	void Destroy();

	//data (publicly available for speed and ease... be careful)
	unsigned int		*m_paryQuickLookupTable;
	
private:
	
	int			CreateGradient();
	
	RGBQUAD			*m_pGradient;
	int			m_nDimensionX;
	int			m_nDimensionY;

	RGBQUAD			*GetElement(int x, int y);

	int			m_nLookupTableElements;
	
	int			FoldGradient();
	int			CircleGradient();
	
};

#endif // !defined(AFX_GRADIENTEX_H__5868E821_3D0B_44D7_8733_4B0843FC1A58__INCLUDED_)
