// PictureHolderEx.h: interface for the CPictureHolderEx class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PICTUREHOLDEREX_H__20300F6E_FB55_4C3C_9FC4_00F87C222675__INCLUDED_)
#define AFX_PICTUREHOLDEREX_H__20300F6E_FB55_4C3C_9FC4_00F87C222675__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <afxctl.h>

class CPictureHolderEx : public CPictureHolder 
{
public:
	// Constructors (including copy and assign!!)
	CPictureHolderEx();
	CPictureHolderEx(const CPictureHolderEx& holder);
	CPictureHolderEx& operator=(const CPictureHolderEx& from);
	
	// clipboard
	BOOL CreateFromClipboard();
	BOOL CopyToClipboard();
	
	// Creation
	BOOL CreateFromEnhMetafile(HENHMETAFILE hemf, 
		BOOL bTransferOwnership);
	
	// Handles to picture objects
	OLE_HANDLE GetHandle();
	
	// Do we have a picture? what type?
	inline bool HasPicture() 
	{ return NULL != m_pPict; }
	inline bool IsBitmap() 
	{ return GetType() == PICTYPE_BITMAP; }
	inline bool IsMetafile() 
	{ return GetType() == PICTYPE_METAFILE; }
	inline bool IsEnhMetafile() 
	{ return GetType() == PICTYPE_ENHMETAFILE; }
	// Allow use of a CPictureHolderEx what an HBITMAP etc 
	// could be used
	inline operator HBITMAP() 
	{ return IsBitmap() ?(HBITMAP)GetHandle() :  NULL; }
	inline operator HMETAFILE() 
	{
		return IsMetafile() ? 
			(HMETAFILE)GetHandle() : NULL; 
	}
	inline operator HENHMETAFILE() 
	{
		return IsEnhMetafile() ? 
			(HENHMETAFILE)GetHandle() : NULL; 
	}
	
	// Load from file etc
	bool OleLoadPictureFromFile(LPCTSTR lpszName);
	bool OleLoadPictureFromCFile(CFile& file);
	bool OleLoadPictureFromGlobal(HGLOBAL hGlobal);
	bool OleLoadPictureFromStream(LPSTREAM lpStream);
	
	// Saving
	bool OleSavePictureToFile(LPCTSTR lpszName);

	// Other operations
	void RenderEZ(CDC* pDC);
	void RenderEZ(CDC* pDC, const CRect& rcRender, const CRect& rcSourcez);
	
	// Get information
	CSize GetDimensions();

	// File extensions allowed
	static const LPCTSTR c_FileExtensions[];
	static const int c_nFileExtensions;
};

#endif // !defined(AFX_PICTUREHOLDEREX_H__20300F6E_FB55_4C3C_9FC4_00F87C222675__INCLUDED_)
