// VisCommonFunctions.h: interface for the CVisCommonFunctions class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_VISUALIZATIONCOMMONFUNCTIONS_H__AD253508_9664_43B4_9FC1_EA2D57D292B4__INCLUDED_)
#define AFX_VISUALIZATIONCOMMONFUNCTIONS_H__AD253508_9664_43B4_9FC1_EA2D57D292B4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define BLEND_MODE_REPLACE		0
#define BLEND_MODE_ADDITIVE		1
#define BLEND_MODE_SUBTRACT		2
#define BLEND_MODE_AVERAGE		3
#define BLEND_MODE_MULTIPLY		4

#include "VisBufferHelper.h"
class CPictureHolderEx;

class CVisCommonFunctions  
{
public:
	CVisCommonFunctions();
	virtual ~CVisCommonFunctions();

	CPictureHolderEx * LoadImageEx(CString strImageFile, long nWidth, long nHeight, BOOL bMaintainAspectRatio = FALSE);
	CPictureHolderEx * LoadImageEx(CString strImageFile);

	long SaveImageAsBmp(CString csExistingFile, CString csNewFile);
	
	long ConvertCartesianToPolar(float X, float Y, float *pRadius, float *pTheta, CSize sizeFull);
	long ConvertPolarToCartesion(float Radius, float Theta, float *pX, float *pY, CSize sizeFull);
	long ConvertPolarToCartesion(float Radius, float Theta, long *pX, long *pY, CSize sizeFull);
	
	void DrawCircleFilled(CVisBufferHelper *pBuffer, float Radius, float Theta, float CircleRadius, unsigned long argbColor, long nBlendMode = BLEND_MODE_REPLACE);
	void DrawLine(CVisBufferHelper *pBuffer, long nX1, long nY1, long nX2, long nY2, unsigned long argbColor);
	void SetPixel(CVisBufferHelper *pBuffer, long nX, long nY, unsigned long argbColor);

	void SaveRectangle(const CRect & Rect, const CString & strKeyName, const CString & strFilename);
	void LoadRectangle(CRect & Rect, const CString & strKeyName, const CString & strFilename);

	void StandardizeRectangle(CRect & Rect);
	
	void ClipLineToDisplay(CPoint & ptA, CPoint & ptB, CSize & sizeDisplay);

private:
	HBITMAP m_hSizedBitmap;
};

#endif // !defined(AFX_VISUALIZATIONCOMMONFUNCTIONS_H__AD253508_9664_43B4_9FC1_EA2D57D292B4__INCLUDED_)
